diff -Naur WindowMaker-0.92.0-orig/src/superfluous.c WindowMaker-0.92.0/src/superfluous.c
--- WindowMaker-0.92.0-orig/src/superfluous.c	2004-10-12 19:46:38.000000000 +0200
+++ WindowMaker-0.92.0/src/superfluous.c	2007-01-10 23:45:03.000000000 +0100
@@ -292,12 +292,45 @@
 #endif /* NORMAL_ICON_KABOOM */
 
 
+static int
+addGhostTile(WScreen *scr, RImage *back, Pixmap which, int dy, int height,
+             unsigned long red_mask, unsigned long green_mask, unsigned long blue_mask)
+{
+    XImage *img;
+    RImage *dock_image;
+
+    img = XGetImage(dpy, which, 0, 0, wPreferences.icon_size, height,
+                    AllPlanes, ZPixmap);
+    if (!img) {
+        RReleaseImage(back);
+        return -1;
+    }
+    img->red_mask = red_mask;
+    img->green_mask = green_mask;
+    img->blue_mask = blue_mask;
+
+    dock_image = RCreateImageFromXImage(scr->rcontext, img, NULL);
+    XDestroyImage(img);
+    if (!dock_image) {
+        RReleaseImage(back);
+        return -1;
+    }
+    RCombineAreaWithOpaqueness(back, dock_image, 0, 0,
+                               wPreferences.icon_size, height,
+                               0, dy, 30 * 256 / 100);
+    RReleaseImage(dock_image);
+    return 0;
+}
+
+
 Pixmap
 MakeGhostDock(WDock *dock, int sx, int dx, int y)
 {
     WScreen *scr = dock->screen_ptr;
+    WDrawerChain *dc;
+    WDock *drawer;
     XImage *img;
-    RImage *back, *dock_image;
+    RImage *back;
     Pixmap pixmap;
     int i, virtual_tiles, h, j, n;
     unsigned long red_mask, green_mask, blue_mask;
@@ -308,6 +341,10 @@
             dock->icon_array[i]->yindex > virtual_tiles)
             virtual_tiles = dock->icon_array[i]->yindex;
     }
+    for (dc = scr->drawers; dc != NULL; dc = dc->next) {
+        if (dc->adrawer->y_pos - dock->y_pos > virtual_tiles * wPreferences.icon_size)
+            virtual_tiles = (dc->adrawer->y_pos - dock->y_pos) / wPreferences.icon_size;
+    }
     virtual_tiles++;
     h = virtual_tiles * wPreferences.icon_size;
     h = (y + h > scr->scr_height) ? scr->scr_height-y : h;
@@ -341,31 +378,25 @@
                 which = dock->icon_array[i]->icon->pixmap;
             else
                 which = dock->icon_array[i]->icon->core->window;
-
-            img=XGetImage(dpy, which, 0, 0, wPreferences.icon_size, n,
-                          AllPlanes, ZPixmap);
-
-            if (!img){
-                RReleaseImage(back);
-                return None;
-            }
-            img->red_mask = red_mask;
-            img->green_mask = green_mask;
-            img->blue_mask = blue_mask;
-
-            dock_image = RCreateImageFromXImage(scr->rcontext, img, NULL);
-            XDestroyImage(img);
-            if (!dock_image) {
-                RReleaseImage(back);
-                return None;
-            }
-            RCombineAreaWithOpaqueness(back, dock_image, 0, 0,
-                                       wPreferences.icon_size, n,
-                                       0, j, 30 * 256 / 100);
-            RReleaseImage(dock_image);
+            if (addGhostTile(scr, back, which, j, n, red_mask, green_mask, blue_mask))
+                return None; /* back is released by addGhostTile */
         }
     }
-
+    for (dc = scr->drawers; dc != NULL; dc = dc->next) {
+        Pixmap which;
+        drawer = dc->adrawer;
+        if (drawer->y_pos >= scr->scr_height)
+            continue;
+        j = drawer->y_pos - dock->y_pos;
+        n = (h - j < wPreferences.icon_size) ? h - j :
+                                               wPreferences.icon_size;
+        if (drawer->icon_array[0]->icon->pixmap)
+            which = drawer->icon_array[0]->icon->pixmap;
+        else
+            which = drawer->icon_array[0]->icon->core->window;
+        if (addGhostTile(scr, back, which, j, n, red_mask, green_mask, blue_mask))
+            return None; /* back is released by addGhostTile */
+    }
 
     RConvertImage(scr->rcontext, back, &pixmap);
 
diff -Naur WindowMaker-0.92.0-orig/src/wdefaults.c WindowMaker-0.92.0/src/wdefaults.c
--- WindowMaker-0.92.0-orig/src/wdefaults.c	2004-10-12 19:49:01.000000000 +0200
+++ WindowMaker-0.92.0/src/wdefaults.c	2007-01-10 23:45:03.000000000 +0100
@@ -609,3 +609,35 @@
     return WMGetFromPLString(value);
 }
 
+
+void
+wDefaultPurgeInfo(WScreen *scr, char *instance, char *class)
+{
+    WMPropList *value, *key, *dict;
+    char *buffer;
+
+    if (!AIcon) { /* Unnecessary precaution */
+        init_wdefaults(scr);
+    }
+
+    WMPLSetCaseSensitive(True);
+
+    buffer = wmalloc(strlen(class) + strlen(instance) + 2);
+    sprintf(buffer, "%s.%s", instance, class);
+    key = WMCreatePLString(buffer);
+
+    dict = WMGetFromPLDictionary(WDWindowAttributes->dictionary, key);
+
+    if (dict) {
+        value = WMGetFromPLDictionary(dict, AIcon);
+        if (value) {
+            WMRemoveFromPLDictionary(dict, AIcon);
+        }
+        WMRemoveFromPLDictionary(WDWindowAttributes->dictionary, key);
+        UpdateDomainFile(WDWindowAttributes);
+    }
+
+    wfree(buffer);
+    WMReleasePropList(key);
+    WMPLSetCaseSensitive(False);
+}
diff -Naur WindowMaker-0.92.0-orig/src/workspace.c WindowMaker-0.92.0/src/workspace.c
--- WindowMaker-0.92.0-orig/src/workspace.c	2007-01-10 23:35:51.000000000 +0100
+++ WindowMaker-0.92.0/src/workspace.c	2007-01-10 23:45:03.000000000 +0100
@@ -106,7 +106,7 @@
 
 
         if (!wPreferences.flags.noclip) {
-            wspace->clip = wDockCreate(scr, WM_CLIP);
+            wspace->clip = wDockCreate(scr, WM_CLIP, NULL);
         } else
             wspace->clip = NULL;
 
diff -Naur WindowMaker-0.92.0-orig/WindowMaker/Defaults/WMWindowAttributes.in WindowMaker-0.92.0/WindowMaker/Defaults/WMWindowAttributes.in
--- WindowMaker-0.92.0-orig/WindowMaker/Defaults/WMWindowAttributes.in	2005-03-22 22:25:23.000000000 +0100
+++ WindowMaker-0.92.0/WindowMaker/Defaults/WMWindowAttributes.in	2007-01-11 00:10:33.000000000 +0100
@@ -2,6 +2,7 @@
   Logo.WMDock = {Icon = GNUstepGlow.#extension#;};
   Logo.WMPanel = {Icon = GNUstep.#extension#;};
   Logo.WMClip = {Icon = clip.#extension#;};
+  WMDrawer = {Icon = Drawer.png;};
   Dockit = {Icon = GNUstep.#extension#;};
   DockApp = {NoAppIcon = NO;};
   WSoundServer = {Icon = sound.#extension#;};
